#include <string.h>
#include <stdint.h>
#include <stdio.h>

#include "e_lib.h"
#include <e_ctimers.h>

typedef uint32_t BF_word;
typedef int32_t BF_word_signed;
typedef BF_word BF_binary[6];

typedef struct
{
	int start[16];
	int test[16];
	int core_done[16];
	char hash[16][61+1];
	char key[16][72+1];
	int done;
} data;

volatile data outbuf SECTION("shared_dram");

static BF_binary BF_out;

int main(void)
{	
	char *hash = (char *)(0x7700);
	char *key = (char *)(0x7800);
	char *setting = NULL;
	int coreID, row, col, corenum, i;
	
	coreID  = e_get_coreid();
	e_coords_from_coreid(coreID, &row, &col);
	row = row - E_FIRST_CORE_ROW;
	col = col - E_FIRST_CORE_COL;
	corenum = row * E_COLS_IN_CHIP + col;
	
	outbuf.core_done[corenum] = 0;
	
	if(corenum == 0)
	{
		outbuf.done = 0;
		while(outbuf.start[corenum] == 0);
		for(i = 0; i < E_ROWS_IN_CHIP * E_COLS_IN_CHIP; i++)
			outbuf.start[i] = 16;
	}

	while(outbuf.start[corenum] == 0);
		
	memcpy((char *)outbuf.key[corenum], key, 72+1);
	memcpy((char *)outbuf.hash[corenum], hash, 61+1);
	
	outbuf.core_done[corenum] = 1;
	
	if(corenum == 0)
	{
		for(i = 0; i < E_ROWS_IN_CHIP * E_COLS_IN_CHIP; i++)
		{
			while(outbuf.core_done[i] == 0);
			outbuf.done++;
		}
	}

	return EXIT_SUCCESS;
}
